unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, StrUtils, SerialNG, ExtCtrls, Menus, Sockets;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    line01: TEdit;
    time01: TEdit;
    phone01: TEdit;
    name01: TEdit;
    SerialPortNG1: TSerialPortNG;
    Memo1: TMemo;
    Bevel1: TBevel;
    Menu: TMainMenu;
    Settings1: TMenuItem;
    Action1: TMenuItem;
    ClearWindow1: TMenuItem;
    Settings2: TMenuItem;
    About1: TMenuItem;
    SendText: TEdit;
    SendButton: TButton;
    checknewline: TCheckBox;
    UdpSocket1: TUdpSocket;
    NetworkSettings1: TMenuItem;
    procedure SendButtonClick(Sender: TObject);
    procedure SerialPortNG1RxClusterEvent(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Settings2Click(Sender: TObject);
    procedure ClearWindow1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure NetworkSettings1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    BufStr : string;
    procedure parseData(S: String);
  end;

var
  Form1: TForm1;

implementation

uses SerialNGBasic, Unit2;

{$R *.dfm}
procedure TForm1.SendButtonClick(Sender: TObject);
begin
  if checknewline.Checked then
    SerialPortNG1.SendString(SendText.Text + chr(13) + chr(10))
  else
    SerialPortNG1.SendString(SendText.Text);
end;

procedure TForm1.SerialPortNG1RxClusterEvent(Sender: TObject);
var str, cha : string;
var i : Integer;
begin
  if SerialPortNG1.NextClusterSize >= 0 then
    begin
        str := SerialPortNG1.ReadNextClusterAsString;
        for i := 1 to Length(str) do
          begin
            cha := MidStr(str, i, 1);
              if cha = chr(13) then
                begin
                  parseData(BufStr);
                  Memo1.Lines.Add(BufStr);
                  BufStr := '';
                end
              else if (cha = chr(10)) or (cha = '?') or (cha = '#') then
                 // do nothing (strip out the newline)
              else
                 // append the BufStr with new character
                 BufStr := BufStr + cha
            end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SerialPortNG1.Active := True;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SerialPortNG1.Active := False;
end;

procedure TForm1.parseData(S: String);
   var ln,io,se,ti,dt,ph,na : String;
begin
   ln := MidStr(S, 1, 2);
   io := MidStr(S, 4, 1);
   se := MidStr(S, 6, 1);
   ti := MidStr(S, 24, 8);
   dt := MidStr(S, 18, 5);
   ph := MidStr(S, 33, 14);
   na := MidStr(S, 48, 14);

   line01.Text := ln;
   time01.Text := ti;
   phone01.Text := ph;
   name01.Text := na;

   if Trim(se) = 'S' then
      if Trim(io) = 'I' then
        begin
          line01.Color := clBlue;
          line01.Font.Color := clWhite;
          time01.Color := clBlue;
          time01.Font.Color := clWhite;
          phone01.Color := clBlue;
          phone01.Font.Color := clWhite;
          name01.Color := clBlue;
          name01.Font.Color := clWhite;
        end
      else
        begin
          line01.Color := clGreen;
          line01.Font.Color := clWhite;
          time01.Color := clGreen;
          time01.Font.Color := clWhite;
          phone01.Color := clGreen;
          phone01.Font.Color := clWhite;
          name01.Color := clGreen;
          name01.Font.Color := clWhite;
        end
   else
        begin
          line01.Color := clWindow;
          line01.Font.Color := clGray;
          time01.Color := clWindow;
          time01.Font.Color := clGray;
          phone01.Color := clWindow;
          phone01.Font.Color := clGray;
          name01.Color := clWindow;
          name01.Font.Color := clGray;
        end;

  if UdpSocket1.Active then
    UdpSocket1.Sendln(S, '');

end;

procedure TForm1.Settings2Click(Sender: TObject);
begin
  SerialNGBasicDLG.SetDLGData(SerialPortNG1);
  if SerialNGBasicDLG.ShowModal = mrOK then
    SerialNGBasicDLG.GetDLGData(SerialPortNG1);
end;

procedure TForm1.ClearWindow1Click(Sender: TObject);
begin
  line01.Color := clWindow;
  line01.Font.Color := clGray;
  time01.Color := clWindow;
  time01.Font.Color := clGray;
  phone01.Color := clWindow;
  phone01.Font.Color := clGray;
  name01.Color := clWindow;
  name01.Font.Color := clGray;
  Memo1.Clear;
  line01.Clear;
  time01.Clear;
  phone01.Clear;
  name01.Clear;
end;


procedure TForm1.About1Click(Sender: TObject);
begin
showMessage('WhozzCalling Listener - http://www.callerid.com'
            + chr(13)
            + 'This program is intended for demonstration purposes ONLY,'
            + chr(13)
            + 'and is NOT SUPPORTED by CallerID.com'
            + chr(13) + chr(13) + chr(13)
            + 'Delphi version uses SerialNG from DomIS http://www.domis.de');
end;

procedure TForm1.NetworkSettings1Click(Sender: TObject);
begin
  Unit2.Form2.SetData(UdpSocket1);
  if Unit2.Form2.ShowModal = mrOK then
    Unit2.Form2.GetData(UdpSocket1);
end;

end.
